#!/bin/bash

date="09.01.2017"
vers="01.01"
echo ""
echo "----- configuration project($vers) $date ------"

omake="work/Makefile"
ih="src/*.h"
ic="src/*.c"
icpp="src/*.cpp"
oh="work"
oc="work"
ocpp="work"
p1=$1


function _help()
{
echo ""
echo "--help    - current screen info"
echo ""
echo "-ic       - interactive config"
echo ""
}

#interactive config
function _ic()
{
  cp $ih $oh
  cp $ic $oc
  cp $icpp $ocpp
  # Шаблон
  echo "############################################" > $omake
  echo "# Makefile Version: $vers   Date: $date" >> $omake
  echo "############################################" >> $omake
  echo "" >> $omake
  echo "#compilators" >> $omake
  echo "CPP		:= g++" >> $omake
  echo "CC		:= gcc" >> $omake
  echo "#" >> $omake
  echo "CFLAGS          := -c -Wall" >> $omake
  # Запросы
  echo "interactive config:"
  echo "Name Project:"
  read p1
  echo "NAME		:= $p1" >> $omake
  echo "Using OpenCV:(1/0)"
  read p1
  if(($p1 > 0))
   then
    echo "INCL		:= -I/usr/local/include/opencv" >> $omake
    echo "LIB		:= -L/usr/local/lib" >> $omake
    echo "CPPLIBRARIES	:= -lopencv_core -lopencv_imgproc -lopencv_highgui -lpthread" >> $omake
   else
    echo "INCL		:=" >> $omake
    echo "LIB		:=" >> $omake
    echo "CPPLIBRARIES	:= -lpthread" >> $omake
  fi
  #Правила
  echo "SRC		:= \$(shell ls *.cpp)" >> $omake
  echo "OBJ		:= \$(SRC: .cpp=.o)" >> $omake
  echo "all:	\$(NAME)" >> $omake
  echo "" >> $omake
  echo "\$(NAME):	\$(OBJ)" >> $omake
  echo "	\$(CPP) \$(LIB) \$(CPPLIBRARIES) \$(OBJ) -o \$(NAME)" >> $omake
  echo "" >> $omake
  echo "\$(OBJ):	\$(SRC)" >> $omake
  echo "	\$(CPP) -c \$(SRC)" >> $omake
  echo "" >> $omake
  echo "clean:" >> $omake
  echo "	rm -f *.o \$(NAME)" >> $omake
}


case $p1 in
  -ic)
   _ic
   ;;
  --help)
   _help
   ;;
  *)
   echo "\"--help\" for info"
   ;;
esac
