//main.c

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include "wcam.h"
#include "main.h"
#include "vcsocket.h"
#include "types.h"
#include "tdef.h"
#include "config.h"
#if((_main_id_type & _cfg_mcntrl) || (_main_id_type & _cfg_move_cam))
	#include "motors.h"
#endif

int main(int argc, char* argv[])
{
	int 	scnt	= 1;
	int	res;
	#if((_main_id_type & _cfg_mcntrl) || (_main_id_type & _cfg_move_cam))
		int 	baudrate	= 9600;
		int 	symbols;
		int 	symwait;
		char	serialname[255] = {"/dev/ttyUSB0"};
	#endif
    	U32 	port;
	wait_dev		= 75000;
	//проверка наличия параметров
	if(argc < 2) 
	{
        	printf("--- Not Parametrs !!!\r\n");
		printf("--- Use \"--help\" for instruction\r\n\r\n");
        	return 1;	//нет параметров
    	}
	while(scnt < argc)
        {
                //подсказка
                if(strcmp(argv[scnt], "--help") == 0)
                {
                        printf(__help1);
			#if((_main_id_type & _cfg_mcntrl) || (_main_id_type & _cfg_move_cam))
				printf(__help2);
			#endif
			#if(_main_id_type & _cfg_OpenCV)
				printf(__help3);
			#endif
			printf(__help4);
                        return 0;
                }
		#if((_main_id_type & _cfg_mcntrl) || (_main_id_type & _cfg_move_cam))
		else if(strcmp(argv[scnt], "--ctest") == 0)
		{
			ctest(&serialname[0], baudrate, wait_dev);
			return 0;
		}
		#endif
		#if(_main_id_type & _cfg_OpenCV)
		//интерактивный тест №1 камеры
                else if(strcmp(argv[scnt], "--vtest1") == 0)
                {
			if(vtest1())
			{
				printf("Not camera detect\n");
				return 2;
			}
                        return 0;
                }
		#endif
		#if(_main_id_type & _cfg_OpenCV)
		//интерактивный тест №2 камеры
                else if(strcmp(argv[scnt], "--vtest2") == 0)
                {
			if(vtest2())
			{
				printf("Not camera detect\n");
				return 2;
			}
                        return 0;
                }
		#endif
		#if(_main_id_type & _cfg_OpenCV)
		//информация о камере
                else if(strcmp(argv[scnt], "--vinfo") == 0)
                {
			if(vinfo())
			{
				printf("Not camera detect\n");
				return 2;
			}
			sleep(1);
			printf("\n==== Camera ====\nwidth:  %i\nheight: %i\n\n", width, height);
                        return 0;
                }
		#endif
		else if(strcmp(argv[scnt], "-p") == 0)
                {
                        scnt++;
			if(!(scnt < argc))
				return 1;		//нет параметра порта
                        port = atoi(argv[scnt]);
                }
		else
		{
			printf("Unknown psrametr: %s\n", argv[scnt]);
			return 4;			//неопределённый параметр
		}
		scnt++;
	}
	//
	tmark	= 0;	//обнуление маркера времени
	//запуск сервера
	if(ServerStart(port) != 0)
	{
		printf("Not starting listen\n");
		sleep(1);
		return 3;
	}
	#if(_main_id_type & _cfg_OpenCV)
	//запуск модуля камеры
	if(CamStart())
	{
		printf("Not camera detect\n");
		sleep(1);
		return 2;
	}
	#endif
	//
	while(1)
	{
		//маркер времени
		if(tmark < 0x0FFF)
			tmark++;
		else
			tmark = 0;
		usleep(_main_sleep);
	}
	//
	return 0;
}
