//id.h

#ifndef _id_h_
#define _id_h_
#include "tdef.h"
#include "config.h"
#include "vcsocket.h"

//
typedef struct _IDMAP
{
	DDID		idserver;		//идентификатор сервера
	u_int8_t	cntid;			//количество клиентов у сервера
	DDID		id[_max_sock];		//идентификаторы клиентов
} IDMAP;

extern DID	mainID;
#if(_mode_server == 0)
extern DID	serverID;	//идентификатор сервера
extern IDMAP	idmap;		//карта идентификаторов
#endif
//
extern void	IDinit(void);
//установка (изменение) номера идентификации
extern void	IDsetNum(u_int16_t num);
#if(_mode_server == 1)
//проверка и новый номер идентификации клиенту
extern u_int32_t	IDNumForClient(u_int8_t * indat, u_int8_t * outdat, int idclient);
#endif
//обработка идентификации
extern u_int32_t	IDworkIDmain(u_int8_t * indat, u_int8_t * outdat);
//формирование запроса идентификации
extern void	IDworkIDrequest(u_int8_t * outdat);
//формирование запроса карты идентификации
extern void	IDworkMAPrequest(u_int8_t * outdat);
//обработка ответа на запрос
extern void	IDworkIDanswer(u_int8_t * indat);

/*
*************************************
внешние запросы
*************************************
*/
#if(_mode_server == 0)
extern u_int16_t 	ReadIDTserver(void);
#endif

#if(_mode_server == 0)
extern u_int16_t 	ReadIDNserver(void);
#endif

#if(_mode_server == 0)
//чтение списка идентификаторов клиетов сервера
extern u_int8_t ReadIDSclients(DDID * ddid);
#endif

#endif

