//tema_socket.c

#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <pthread.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/time.h>
#include <sys/types.h>		//наши определения типов - для удобства
#include "vcsocket.h"		//подключаем наш заголовочный файл для работы с сокетами
#include "main.h"		//подключаем заголовочный файл нашего MAIN
#include "tdef.h"
#include "config.h"
#include "id.h"
#if((_func_cam == 1) || (_mode_server == 0))
	#include "wcam.h"
#endif

u_int16_t		tmark;
//
struct  sockaddr_in     addr;

#if(_mode_server == 1)
	int	listener;
	pthread_mutex_t         ServerMutex;
	pthread_t     		hListenProcess;
	int	 		TServerMutex;
	WSERV			WServer;
#else
	int			clsocket;
	pthread_mutex_t         ClientMutex;
	pthread_t     		hClientProcess;
	int	 		TClientMutex;
	WTCP			WClient;
#endif

#if(_mode_server == 1)
int	ServerStart(int ipport)
{
	pthread_attr_t tattr;
	pthread_attr_init(&tattr);
	pthread_attr_setdetachstate(&tattr, PTHREAD_CREATE_DETACHED);
	//
       	listener = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
        if(listener < 0)
                return -1;
        addr.sin_family = AF_INET;
        addr.sin_port = htons(ipport);
        addr.sin_addr.s_addr = htonl(INADDR_ANY);
        memset(&addr.sin_zero, 0, 8);
        if(bind(listener, (struct sockaddr *)&addr, sizeof(addr)) < 0)
                return -2;
        if(listen(listener, _max_sock) < 0)
                return -3;
        //создаём мютекс
        if(!(pthread_mutex_init(&ServerMutex,NULL) == 0))
                return -4;
        //запуск потока прослушивания
        WServer.work = 1;	//флаг "работы"
        pthread_create(&hListenProcess, &tattr, ListenProcess, NULL);
	//
        sleep(1);       //wait one secoond
        //
        return 0;
}
#else
int ClientStart(char * strip, int ipport)
{
	struct  hostent *ht;
	pthread_attr_t tattr;
	pthread_attr_init(&tattr);
	pthread_attr_setdetachstate(&tattr, PTHREAD_CREATE_DETACHED);
	//
	clsocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	//
	addr.sin_family = AF_INET;
	addr.sin_port = htons(ipport);
	//addr.sin_addr.s_addr = inet_addr((char*)(strip));
	ht = gethostbyname((char*)(strip));
	addr.sin_addr.s_addr = *(ulong*)(ht->h_addr_list[0]);
	memset(&addr.sin_zero, 0, 8);
	if(connect(clsocket, (struct sockaddr *)&addr, sizeof(addr)) < 0)
		return -2;
	//создаём мютекс
        if(!(pthread_mutex_init(&ClientMutex,NULL) == 0))
                return -4;
	//стартуем процесс клиента
	WClient.csock		= clsocket;
	WClient.work		= 1;
	WClient.setcntlive	= _time_life;
	//
	IDinit();
        pthread_create(&hClientProcess, &tattr, ClientProcess, &WClient);
    //
	return 0;
}
#endif

#if(_mode_server == 1)
int ServerStop(void)
{
	pthread_mutex_lock(&ServerMutex);
	close(listener);
	WServer.work = 0;
	pthread_mutex_unlock(&ServerMutex);
	return 0;
}
#else
int ClientStop(void)
{
	pthread_mutex_lock(&ClientMutex);
	close(clsocket);
	WClient.work = 0;
	pthread_mutex_unlock(&ClientMutex);
	return 0;
}
#endif

//статус соединения
int StatConnect(void)
{
	int	res;
	#if(_mode_server == 1)
		pthread_mutex_lock(&ServerMutex);
		res	= (int)WServer.work;
		pthread_mutex_unlock(&ServerMutex);
	#else
		pthread_mutex_lock(&ClientMutex);
		res	= (int)WClient.work;
		pthread_mutex_unlock(&ClientMutex);
	#endif
	return res;
}

//маркер времени
int ReadTmark(void)
{
	int res;
	#if(_mode_server == 1)
		pthread_mutex_lock(&ServerMutex);
		res	= (int)(tmark);
		pthread_mutex_unlock(&ServerMutex);
	#else
		pthread_mutex_lock(&ClientMutex);
		res	= (int)(tmark);
		pthread_mutex_unlock(&ClientMutex);
	#endif
	return res;
}

#if(_mode_server == 1)
//поток прослушивания
void * ListenProcess(void * pr)
{
        int 		err;
        fd_set 		fdss;
        struct timeval 	tvs;
        int 		count;
        int 		csock;
	pthread_attr_t 	tattr;
	//параметры для отделяемых потоков
	pthread_attr_init(&tattr);
	pthread_attr_setdetachstate(&tattr, PTHREAD_CREATE_DETACHED);
        //инициализация данных - сервер нулевая точка
        memset(&WServer.midcl[0], 0, _max_sock);		//список клиентов
        WServer.cntclient = 1;					//регистрируем сервер как точку
	WServer.dtcp[0].set_pr_ssleep	= _cl_pr_ssleep;
	WServer.dtcp[0].setcntlive	= _time_life;
	//основной цикл прослушивания
        while(WServer.work)
        {
mt1:            tvs.tv_sec = 0;
                tvs.tv_usec = _LSOCKET_TIMEOUT;
                FD_ZERO(&fdss);
                FD_SET(listener,&fdss);
                //
                err = select(listener + 1,&fdss,&fdss,NULL,&tvs);
                if(err <= 0)
                {
                        usleep(_SSLEEP);
                        goto mt1;
                }
                csock = accept(listener,NULL,NULL);
		//создание потока клиента
		#if(_mode_dbg)
                	printf("-- CLIENT sock. %i --\r\n", csock);
		#endif
                count = 0;
                while(count < _max_sock)
                {
                        if(WServer.midcl[count] == 0)
                        {
                                WServer.idclient 		= count;	//номер клиента - передача параметра
				WServer.dtcp[count].csock	= csock;	//принятый для работы сокет клиента
				WServer.midcl[count]		= 0xFF;		//место клиента зафиксировано
                                //pthread_create(&WServer.pth[count],NULL,(void*) ClientProcess, &WServer);	//неотделяемый поток
				pthread_create(&WServer.dtcp[count].pth, &tattr,  ServerProcess, &WServer);	//отделяемый поток
                                WServer.cntclient++;				//счётчик клиентов
				break;
                        }
                        count++;
                }
                //
                //usleep(TServerMutex);
                usleep(_pr_ssleep);
        }
	pthread_exit(0);
}
#endif

inline int ReadSocket(int nSocket, u_int8_t *pBuffer)
{
        //int     res                     = 1;
        int     	iRC                     = 0;
        int     	iReceiveStatus          = 0;
        int     	iStillToReceive         = 4;	//начальный размер получения минимальных данных
        int     	iCount 	= 0;
	int		sz;
        struct timeval 	ReceiveTimeout;
        fd_set 		fds;
	u_int8_t		flag			= 0;	//флаг получения размера для приёма
	//
        while(iStillToReceive > 0)
        {
                //установка величины таймаута
                FD_ZERO(&fds);
                FD_SET(nSocket, &fds);
                ReceiveTimeout.tv_sec  = 0;
                ReceiveTimeout.tv_usec = _rSOCKET_TIMEOUT_;
                iRC = select(nSocket + 1, &fds, NULL, NULL, &ReceiveTimeout);
                //выход по таймауту
                if(!iRC)
			return -1;
		//произошла какая то ошибка
                if(iRC < 0)
                        return -2;
		//ошибка указания размера данных
                if(iStillToReceive <= 0)
                        return -3;
                //прием нескольких байт
		iReceiveStatus = recv(nSocket, (char*)(pBuffer), iStillToReceive, 0);
                if(iReceiveStatus >  0)
                {
			pBuffer += iReceiveStatus;
                        iStillToReceive -= iReceiveStatus;
                        iCount += iReceiveStatus;
			if((iCount >= 4) && (flag == 0))
			{ 
				sz		= (*(u_int32_t*)(pBuffer - iCount));
				iStillToReceive = sz - iCount;
				flag = 0xFF;
			}
                }
		else if(iReceiveStatus == 0)
			return -1;
		else
			return -2;
        }
	//дополнительная проверка размера
	if(sz != iCount)
		return -3;
        //
        return iCount;
}


inline int WriteSocket(int nSocket, u_int8_t *pBuffer, u_int32_t iMessageLength)
{
 	int 		iCount		= 0;
        int 		iSC 		= 0;
        int 		iSendStatus 	= 0;
        struct timeval 	SendTimeout;
        fd_set 		fds;
	//fcntl(nSocket, F_SETFL, O_NONBLOCK);
        while(iMessageLength > 0)
        {
		//установка величины таймаута
        	SendTimeout.tv_sec  = 0;
        	SendTimeout.tv_usec = _wSOCKET_TIMEOUT_;
        	FD_ZERO(&fds);
        	FD_SET(nSocket, &fds);
                iSC = select(nSocket + 1, NULL, &fds, NULL, &SendTimeout);
                if(!iSC)
                        return -1; //таймаут
                if(iSC < 0)
                        return -2; //ошибка
		//отправить несколько байт
		iSendStatus = send(nSocket, (char*)(pBuffer), iMessageLength, 0);
                if(iSendStatus > 0)
                {
                        //обновить буфер и счетчик
                        iMessageLength -= iSendStatus;
                        pBuffer += iSendStatus;
                        iCount += iSendStatus;
                }
		else if(iSendStatus == 0)
			return -1;
		else
			return -2;
        }
	return iCount;
}


#if(_mode_server == 1)
//поток работы с входящим соединением
void * ServerProcess(void * cs)
{
	int		countlive	= _time_life;
	//int		setcntlive;
	int		csock;
	int		idclient;
	WSERV		*css		= (WSERV*)(cs);
	pthread_t	pth;
	u_int8_t		midcl;
	u_int8_t		rxbuf[_tcp_size];	//буфер приёма
	u_int8_t		txbuf[_tcp_size];	//буфер передачи
	u_int32_t		txsz 		= 0;
	u_int8_t		work;
	int		res;
	//
	#if(_mode_dbg)
		printf("---- CLIENT START ----\n");
	#endif
	//занимаем мютекс
	pthread_mutex_lock(&ServerMutex);
	//
	//countlive 	= cs->setcntlive;
	//setcntlive	= cs->setcntlive;
	idclient	= css->idclient;		//взяли номер
	csock		= css->dtcp[idclient].csock;
	//midcl		= css->midcl[idclient];
	pth		= css->dtcp[idclient].pth;
	work		= css->work;
	//
	pthread_mutex_unlock(&ServerMutex);
	//
	while(work)
	{
		//чтение сокета
		txsz = 0;
		memset(&rxbuf[0], 0, _tcp_size);
		res = ReadSocket(csock, &rxbuf[0]);
		#if(_mode_dbg)
			printf("---- From CLIENT receive: %i\n", res);
		#endif
		switch(res)
		{
			case 0:	//Null
				goto mexit;
			case -1: 			//таймаут
				goto mexit;
			case -2: 			//какая-то ошибка сокета
				goto mexit;
			case -3: 			//ошибка размера пакета
				break;
			default: 			//нормально - данные приняты
				countlive = _time_life;
				break;
		}
		//обработка запроса
		pthread_mutex_lock(&ServerMutex);
		//идентификаторы в данные клиента
		WServer.dtcp[idclient].id.id_tin	= (*(u_int16_t*)(&rxbuf[_id_tin0])); 
		WServer.dtcp[idclient].id.id_nin	= (*(u_int16_t*)(&rxbuf[_id_nin0]));
		WServer.dtcp[idclient].id.id_tout 	= (*(u_int16_t*)(&rxbuf[_id_tout0]));
		WServer.dtcp[idclient].id.id_nout 	= (*(u_int16_t*)(&rxbuf[_id_nout0]));
		//проверка на совпадения идентификационного номера и изменение
		txsz = IDNumForClient(&rxbuf[0], &txbuf[0], idclient);
		if(txsz == 0) //изменение номера клиента не требуется
		{
			//проверяем по номеру идентификации
			if( ((*(u_int16_t*)(&rxbuf[_id_nin0])) == 0) ||	//по нулевому номеру то только к серверу
			((*(u_int16_t*)(&rxbuf[_id_nin0])) == mainID.id_nout))	//моя идентификация
			{
				switch(rxbuf[_idtype])	//по типу обращения
				{
					case _idtype_ID:	//работа с идентификацией
						txsz = IDworkIDmain(&rxbuf[0], &txbuf[0]);
						break;
					#if(_main_id_type & _cfg_OpenCV)
					case _idtype_cam_video:	//веб-кмера
						txsz = ServerCam(&rxbuf[0], &txbuf[0]);		//сервер камеры
						break;
					#endif
					default:	//тип обращения не понятен
						txsz = 0;
						#if(_mode_dbg)
							printf("---- TYPE ID Not Defined: %i\n", rxbuf[_idtype]);
						#endif
						break;
				}
			}
		}
		//txsz	= (*(u_int32_t*)(&txbuf[_tcp_sz0]));
		pthread_mutex_unlock(&ServerMutex);
		#if(_mode_dbg)
			printf("---- SIZE To CLIENT send: %i\n", txsz);
		#endif
		//передача данных
		if(txsz > 0)
		{
			//pthread_mutex_unlock(&ServerMutex);
			res = WriteSocket(csock, &txbuf[0], txsz);
			#if(_mode_dbg)
				printf("---- To CLIENT send: %i\n", res);
			#endif
			switch(res)
			{
				case 0:
					goto mexit;
				case -1:		//таймаут
					goto mexit;
				case -2:		//какая-то ошибка сокета
					goto mexit;
				default:		//нормально - данные переданы
					//countlive = _time_life;
					//printf("--send: %i\n", res);
					break;
			}
		}
		//ожидание и новый цикл
		usleep(_cl_pr_ssleep);
		countlive--;
		if(!(countlive > 0)) //никому это соединение не нужно
			break;
	}
mexit:	close(csock);
	pthread_mutex_lock(&ServerMutex);
	css->dtcp[idclient].pth	= 0;
	css->midcl[idclient]	= 0;
	css->cntclient--;
	pthread_mutex_unlock(&ServerMutex);
	#if(_mode_dbg)
		printf("---- CLIENT STOP ----\n");
	#endif
	pthread_exit(0); 
}
#else

//поток работы с исходящим соединением
void * ClientProcess(void * cs)
{
	WTCP	ccs, ccs1;
    	int     res;
    	//u_int16_t     iit,iin;
    	//u_int16_t     iot,ion;
	u_int8_t	rxbuf[_tcp_size];
	u_int8_t	txbuf[_tcp_size];
	int	num = 0;		//номер типа обращения
    //
	memcpy(&ccs, cs, sizeof(WTCP));
	//
	while(ccs.work)
	{
        pthread_mutex_lock(&ClientMutex);
	//формирование запроса
	(*(u_int16_t*)(&txbuf[_id_tout0]))	= mainID.id_tout;	//передаём свой идентификатор типа
	(*(u_int16_t*)(&txbuf[_id_nout0]))	= mainID.id_nout;	//передаём свой номер
	//
	switch(num)
	{
		case 0:
			IDworkIDrequest(&txbuf[0]);
			num++;
			break;
		case 1:
			IDworkMAPrequest(&txbuf[0]);
			num++;
			break;
		case 2:
			ClietVCamPktCreate(&txbuf[0]);
			num = 0;
			break;
		default:
			num = 0;
			break;
	}
	//
        //передача
        res =   WriteSocket(ccs.csock, &txbuf[0], (*(u_int32_t*)(&txbuf[_tcp_sz0])));
	#if(_mode_dbg)
                printf("-- CLIENT send. %i --\r\n", res);
	#endif
	switch(res)
	{
		case 0:
			goto me;
		case -1:		//таймаут
			goto me;
		case -2:		//какая-то ошибка сокета
			goto me;
		default:		//нормально - данные переданы
			//countlive = _time_life;
			//printf("--send: %i\n", res);
			break;
	}
        //приём
        res =   ReadSocket(ccs.csock, &rxbuf[0]);
	#if(_mode_dbg)
               	printf("-- CLIENT receive. %i --\r\n", res);
	#endif
        switch(res)
        {
            case 0:	//Null
                break;
            case -1: 			//таймаут
                break;
            case -2: 			//какая-то ошибка сокета
                goto me;
            case -3: 			//ошибка размера пакета
                break;
            default: 			//нормально - данные приняты
                ccs.cntlive		= ccs.setcntlive;
                //читаем идентификаторы
                WClient.id.id_tin	= (*(u_int16_t*)(&rxbuf[_id_tin0]));
                WClient.id.id_nin	= (*(u_int16_t*)(&rxbuf[_id_nin0]));
                WClient.id.id_tout	= (*(u_int16_t*)(&rxbuf[_id_tout0]));
                WClient.id.id_nout	= (*(u_int16_t*)(&rxbuf[_id_nout0]));
                //сверяем идентификаторы
                if(WClient.id.id_nin == mainID.id_nout)  //совпало по номеру
                {
			#if(_mode_dbg)
               			printf("-- Main ID Num --\r\n");
			#endif
			tmark	= (*(u_int16_t*)(&rxbuf[_mtime0]));	//маркер времени
			//обработтка кода операции
			switch(rxbuf[_cop])
			{
				case _cop_answer:	//ответ
					//тип обращения
					switch(rxbuf[_idtype])
					{
						case _idtype_ID:	//идентификатор
							IDworkIDanswer(&rxbuf[0]);
							break;
						case _idtype_cam_video:	//видеоданные с камеры
							ClientVCamPktAnswer(&rxbuf[0]);
							break;
						default:
							#if(_mode_dbg)
								printf("ANSWER not work\n");
								printf("resv u_int8_ts: ");
								u_int32_t sz1		= (*(u_int32_t*)(&rxbuf[_tcp_sz0]));
								u_int32_t cnts1	= 0;
								while(cnts1 < sz1)
								{
									printf("%02X ", (*(u_int8_t*)(&rxbuf[cnts1])));
									cnts1++;
								}
								printf("\n");
							#endif
							break;
					}
					break;
				case _cop_wr:		//запись от сервера
					//тип обращения
					switch(rxbuf[_idtype])
					{
						case _idtype_ID:	//идентификатор
							IDworkIDmain(&rxbuf[0], &txbuf[0]);	//обработка команды идентификатора
							//pthread_mutex_unlock(&ClientMutex);
							break;
						default:
							#if(_mode_dbg)
								printf("COP WR not work\n");
								printf("resv u_int8_ts: ");
								u_int32_t sz1		= (*(u_int32_t*)(&rxbuf[_tcp_sz0]));
								u_int32_t cnts1	= 0;
								while(cnts1 < sz1)
								{
									printf("%02X ", (*(u_int8_t*)(&rxbuf[cnts1])));
									cnts1++;
								}
								printf("\n");
							#endif
							break;
					}
					break;
				default:
					#if(_mode_dbg)
						printf("RECV COP not work\n");
						printf("resv u_int8_ts: ");
						u_int32_t sz		= (*(u_int32_t*)(&rxbuf[_tcp_sz0]));
						u_int32_t cnts	= 0;
						while(cnts < sz)
						{
							printf("%02X ", (*(u_int8_t*)(&rxbuf[cnts])));
							cnts++;
						}
						printf("\n");
					#endif
					break;
			}
                }
                break;
        }
	//анализ ответа
        //ClientVCamPktAnswer(&rxbuf[0]);
        //
        if(ccs.cntlive > 0)
            ccs.cntlive--;
        else
            goto me;
	//
	memcpy(&ccs1, cs, sizeof(WTCP));
	ccs.work = ccs1.work;
	//
        pthread_mutex_unlock(&ClientMutex);
		usleep(ccs.set_pr_ssleep);
	}
	//
	pthread_mutex_lock(&ClientMutex);
me:	close(ccs.csock); 	
	ccs.pth     	= 0;		//обнуляем поток в структуре клиента
    	ccs.work    	= 0;
	ccs.csock	= 0;
	memcpy(cs, &ccs, sizeof(WTCP));
	pthread_mutex_unlock(&ClientMutex);
    	#if(_mode_dbg)
		printf("-- CLIENT End.\r\n");
	#endif
	pthread_exit(0);
}
#endif




