#include "config.h"
#include "tdef.h"
#if(_main_id_type & _cfg_OpenCV)
	#include <iostream>
	#include <opencv2/imgproc/imgproc.hpp>
	#include <opencv2/imgproc/imgproc_c.h>
	#include <opencv2/highgui/highgui.hpp>
#endif
#include "wcam.h"
#include <sys/types.h>
#include <string.h>
#include "vcsocket.h"
#include "id.h"
#include <stdio.h>
#include <pthread.h>

u_int16_t 	width;
u_int16_t 	height;
u_int8_t	vbuf[640][480];
u_int8_t	vbuf1[640][480];
u_int8_t	vbuf2[640][480];
u_int8_t	vbuf3[640][480];

#if(_main_id_type & _cfg_OpenCV)
	cv::Mat gray;
	cv::Mat adapt;
	cv::Mat ga;
	//параметры для процедур
	u_int8_t	ap1;
	u_int8_t	ap2;
#endif


#if(_main_id_type & _cfg_OpenCV)
	CvCapture* 	capture;
	pthread_t	hCamLoop;
#endif

#if(_main_id_type & _cfg_OpenCV)
//тестовый интерактивеый модуль 1
int vtest1(void)
{
	int	num = 0;
	//
	capture = cvCreateCameraCapture(0);
	if(!(capture))
		return 1;
	while(1)
	{
		cv::Mat src = cvQueryFrame(capture);

    		cv::imshow("src", src);

    		// Create binary image from source image
    		cv::Mat bw;
    		cv::cvtColor(src, bw, CV_BGR2GRAY);
    		cv::threshold(bw, bw, 40, 255, CV_THRESH_BINARY);
		if(num == 0)
			cv::imshow("out", bw);

    		// Perform the distance transform algorithm
    		cv::Mat dist;
    		cv::distanceTransform(bw, dist, CV_DIST_L2, 3);

    		// Normalize the distance image for range = {0.0, 1.0}
    		// so we can visualize and threshold it
    		cv::normalize(dist, dist, 0, 1., cv::NORM_MINMAX);
		if(num == 1)
			cv::imshow("out", dist);

    		// Threshold to obtain the peaks 
    		// This will be the markers for the foreground objects
    		cv::threshold(dist, dist, .5, 1., CV_THRESH_BINARY);
		if(num == 2)
			cv::imshow("out", dist);

    		// Create the CV_8U version of the distance image
    		// It is needed for cv::findContours()
    		cv::Mat dist_8u;
    		dist.convertTo(dist_8u, CV_8U);

    		// Find total markers
   	 	std::vector<std::vector<cv::Point> > contours;
   		cv::findContours(dist_8u, contours, CV_RETR_EXTERNAL, CV_CHAIN_APPROX_SIMPLE);
    		int ncomp = (int) contours.size();

    		// Create the marker image for the watershed algorithm
    		cv::Mat markers = cv::Mat::zeros(dist.size(), CV_32SC1);

    		// Draw the foreground markers
    		for (int i = 0; i < ncomp; i++)
			cv::drawContours(markers, contours, i, cv::Scalar::all(i+1), -1);

    		// Draw the background marker
    		cv::circle(markers, cv::Point(5,5), 3, CV_RGB(255,255,255), -1);
		if(num == 3)
			cv::imshow("out", markers*10000);

    		// Perform the watershed algorithm
    		cv::watershed(src, markers);

    		// Generate random colors
    		std::vector<cv::Vec3b> colors;
    		for (int i = 0; i < ncomp; i++)
    		{
	    		int b = cv::theRNG().uniform(0, 255);
	    		int g = cv::theRNG().uniform(0, 255);
	    		int r = cv::theRNG().uniform(0, 255);

	    		colors.push_back(cv::Vec3b((uchar)b, (uchar)g, (uchar)r));
    		}

    		// Create the result image
    		cv::Mat dst = cv::Mat::zeros(markers.size(), CV_8UC3);

    		// Fill labeled objects with random colors
    		for (int i = 0; i < markers.rows; i++)
    		{
			for (int j = 0; j < markers.cols; j++)
			{
	    		int index = markers.at<int>(i,j);
        		dst.at<cv::Vec3b>(i,j) = index > 0 && index <= ncomp ? colors[index - 1] : cv::Vec3b(0, 0, 0);
			}
    		}
		if(num == 4)
		cv::imshow("out", dst);
		//gray
		cv::Mat gray;
    		cv::cvtColor(src, gray, CV_BGR2GRAY);
		if(num == 5)
			cv::imshow("out", gray);
		//adaptive
		cv::Mat adapt = cv::Mat::zeros(markers.size(), CV_8UC3);
		cv::adaptiveThreshold(gray, adapt, 255, CV_ADAPTIVE_THRESH_MEAN_C, CV_THRESH_BINARY, 11, 1);
		if(num == 6)
			cv::imshow("out", adapt);
		// Find total markers
    		std::vector<std::vector<cv::Point> > acontours;
    		cv::findContours(adapt, acontours, CV_RETR_EXTERNAL, CV_CHAIN_APPROX_SIMPLE);
    		int ancomp = (int) acontours.size();

    		// Create the marker image for the watershed algorithm
    		cv::Mat amarkers = cv::Mat::zeros(dist.size(), CV_32SC1);

    		// Draw the foreground markers
    		for (int i = 0; i < ancomp; i++)
			cv::drawContours(amarkers, acontours, i, cv::Scalar::all(i+1), -1);
		// Perform the watershed algorithm
    		cv::watershed(src, amarkers);
		if(num == 7)
			cv::imshow("out", amarkers*500);

    		//cv::waitKey(0);
    		char c = cvWaitKey(33);
    		if (c == 27) { // нажата ESC
        		break; }
		else if(c == 0x31)
			num = 0;
		else if(c == 0x32)
			num = 1;
		else if(c == 0x33)
			num = 2;
		else if(c == 0x34)
			num = 3;
		else if(c == 0x35)
			num = 4;
		else if(c == 0x36)
			num = 5;
		else if(c == 0x37)
			num = 6;
		else if(c == 0x38)
			num = 7;

	}  
	return 0;
}
#endif

#if(_main_id_type & _cfg_OpenCV)
//тестовый интерактивеый модуль 2
int vtest2(void)
{
	int	num = 0;
	//
	capture = cvCreateCameraCapture(0);
	if(!(capture))
		return 1;
	while(1)
	{
		cv::Mat src = cvQueryFrame(capture);
		//чёрно-белая картинка
		cv::Mat gray;
    		cv::cvtColor(src, gray, CV_BGR2GRAY);
    		cv::imshow("src gray", gray);
		//adaptive
		cv::Mat adapt = cv::Mat::zeros(gray.size(), CV_8UC1);
		cv::adaptiveThreshold(gray, adapt, 255, CV_ADAPTIVE_THRESH_MEAN_C, CV_THRESH_BINARY, 5, 1);
		if(num == 0)
			cv::imshow("out", adapt);
		//
		ga = gray & adapt;
		if(num == 1)
			cv::imshow("out", ga);

		//
    		char c = cvWaitKey(33);
    		if (c == 27) { // нажата ESC
        		break; }
		else if(c == 0x31)
			num = 0;
		else if(c == 0x32)
			num = 1;
		else if(c == 0x33)
			num = 2;
		else if(c == 0x34)
			num = 3;
		else if(c == 0x35)
			num = 4;
		else if(c == 0x36)
			num = 5;
		else if(c == 0x37)
			num = 6;
		else if(c == 0x38)
			num = 7;

	}  
	return 0;
}
#endif

#if(_main_id_type & _cfg_OpenCV)
//информация о параметрах камеры
int vinfo(void)
{
	capture = cvCreateCameraCapture(0);
	if(!(capture))
		return 1;
	width = (int)(cvGetCaptureProperty(capture, CV_CAP_PROP_FRAME_WIDTH));
        height = (int)(cvGetCaptureProperty(capture, CV_CAP_PROP_FRAME_HEIGHT));
	//
	cvReleaseCapture(&capture);
	return 0;
}
#endif

#if(_main_id_type & _cfg_OpenCV)
//запуск процесса камеры
int CamStart(void)
{
	pthread_attr_t 	tattr;
	//параметры для отделяемых потоков
	pthread_attr_init(&tattr);
	pthread_attr_setdetachstate(&tattr, PTHREAD_CREATE_DETACHED);
	//
	capture = cvCreateCameraCapture(0);
	if(!(capture))
		return 1;
	width = (int)(cvGetCaptureProperty(capture, CV_CAP_PROP_FRAME_WIDTH));
        height = (int)(cvGetCaptureProperty(capture, CV_CAP_PROP_FRAME_HEIGHT));
	//
	pthread_create(&hCamLoop, &tattr,  CamLoop, NULL);	//отделяемый поток
	//
	//
	return 0;
}
#endif

#if(_main_id_type & _cfg_OpenCV)
//рабочий процесс камеры
void* CamLoop(void * pr)
{
	cv::Mat src;
	//
	ap1 = 3;
	ap2 = 1;
	//
	tmark = 0;
	//
	printf("start camm loop...\n");
	//
	while(1)
	{
		src = cvQueryFrame(capture);
		pthread_mutex_lock(&ServerMutex);
		//
		cv::cvtColor(src, gray, CV_BGR2GRAY);
		adapt = cv::Mat::zeros(gray.size(), CV_8UC1);
		ap1 |= 3;
		//
		cv::adaptiveThreshold(gray, adapt, 255, CV_ADAPTIVE_THRESH_MEAN_C, CV_THRESH_BINARY, ap1, ap2);
		//
		ga = gray & adapt;
		tmark++;
		pthread_mutex_unlock(&ServerMutex);
		usleep(_wait_cam);
	}
	//
	pthread_exit(0);
}
#endif

#if(_main_id_type & _cfg_OpenCV)
//чтение данных на передачу клиенту
void vdataRead(u_int8_t vtype, u_int8_t * ob)
{
	u_int32_t	cntx, cnty, cntbyte;
	//
	cnty 	= 0;
	cntbyte	= 0;
	//
	//pthread_mutex_lock(&ServerMutex);
	//
	while(cnty < height)
	{
		cntx = 0;
		while(cntx < width)
		{
			switch(vtype)
			{
				case _vtype_scr8:	//картинка
					(*(u_int8_t*)(ob + cntbyte)) = gray.at<char>(cnty,cntx);
					break;
				case _vtype_scr_at:	//адаптивная бинаризация
					(*(u_int8_t*)(ob + cntbyte)) = adapt.at<char>(cnty,cntx);
					break;
				case _vtype_scr_ap:	//картинка И адаптивная бинаразация
					(*(u_int8_t*)(ob + cntbyte)) = ga.at<char>(cnty,cntx);
					break;
				default:
					break;
			}
			cntx++;
			cntbyte++;
		}
		cnty++;
	}
	//pthread_mutex_unlock(&ServerMutex);
}
#endif

/*
*/
#if(_main_id_type & _cfg_OpenCV)
//работа с данными камеры
u_int32_t ServerCam(u_int8_t * rxbuf, u_int8_t * txbuf)
{
	u_int32_t	txsz;
	//u_int8_t	vtype;
	u_int16_t	tin,nin;
	//
	//vtype	= (*(u_int8_t*)(rxbuf + _vtype));
	tin	= (*(u_int16_t*)(rxbuf + _id_tout0));
	nin	= (*(u_int16_t*)(rxbuf + _id_nout0));
	//
	switch((*(u_int8_t*)(rxbuf + _vtype)))
	{
		case _vtype_scr8:						//запрос картинки
			//(*(u_int8_t*)(txbuf + _vtype))			= cmd;
			(*(u_int16_t*)(txbuf + _id_tin0))		= tin;
			(*(u_int16_t*)(txbuf + _id_nin0))		= nin;
			(*(u_int16_t*)(txbuf + _id_tout0))		= mainID.id_tout;
			(*(u_int16_t*)(txbuf + _id_nout0))		= mainID.id_nout;
			(*(u_int8_t*)(txbuf + _idtype))			= _idtype_cam_video;
			(*(u_int8_t*)(txbuf + _vtype))			= _vtype_scr8;		//тип обращения - картинка и т.п.
			if((*(u_int8_t*)(rxbuf + _cop)) == _cop_rd)
			{
				(*(u_int8_t*)(txbuf +_cop))		= _cop_answer;	//ответ
				(*(u_int8_t*)(txbuf + _vlayer))		= 0;		//слой
				(*(u_int16_t*)(txbuf + _vwidht))	= width;	//ширина
				(*(u_int16_t*)(txbuf + _vheight))	= height;	//высота
				(*(u_int16_t*)(txbuf + _mtime0))	= tmark;	//маркер времени
				vdataRead(_vtype_scr8, txbuf + _vdaddr);
				txsz = (width * height) + _vdaddr + 1;
				(*(u_int32_t*)(txbuf + _tcp_sz0))	= txsz;		//размер пакета TCP
			}
			break;
/*			case _vtype_scr_at:						//adapt
				(*(u_int8_t*)(txbuf + _vtype))	= _vtype_scr_at;			//тип обращения - картинка и т.п.
				ap1		= rxbuf[_ap1];
				ap2		= rxbuf[_ap2];
				if((*(u_int8_t*)(rxbuf + _vcop)) & _vcop_rd)
				{
					txbuf[_vcop]	= _vcop_rd;			//код операции - чтение
					(*(u_int16_t*)(txbuf + _vwidht))	= width;	//ширина
					(*(u_int16_t*)(txbuf + _vheight))	= height;	//высота
					(*(u_int16_t*)(txbuf + _mtime0))	= tmark;	//маркер времени
					vdataRead(_vtype_scr_at, txbuf + _vdaddr);
					txsz = (width * height) + _vdaddr;
					(*(u_int32_t*)(txbuf + _tcp_sz0))	= txsz;		//размер пакета TCP
				}
				break;
			case _vtype_scr_ap:						//adapt
				(*(u_int8_t*)(txbuf + _vtype))	= _vtype_scr_ap;			//тип обращения - картинка и т.п.
				ap1		= rxbuf[_ap1];
				ap2		= rxbuf[_ap2];
				if((*(u_int8_t*)(rxbuf + _vcop)) & _vcop_rd)
				{
					txbuf[_vcop]	= _vcop_rd;			//код операции - чтение
					(*(u_int16_t*)(txbuf + _vwidht))	= width;	//ширина
					(*(u_int16_t*)(txbuf + _vheight))	= height;	//высота
					(*(u_int16_t*)(txbuf + _mtime0))	= tmark;	//маркер времени
					vdataRead(_vtype_scr_ap, txbuf + _vdaddr);
					txsz = (width * height) + _vdaddr;
					(*(u_int32_t*)(txbuf + _tcp_sz0))	= txsz;		//размер пакета TCP
				}
				break;*/
			default:					//ничего не передаём
				txsz		= 0;
				#if(_mode_dbg)
					printf("RD CAM not work\n");
					printf("resv u_int8_ts: ");
					u_int32_t sz		= (*(u_int32_t*)(rxbuf + _tcp_sz0));
					u_int32_t cnts		= 0;
					while(cnts < sz)
					{
						printf("%02X ", (*(u_int8_t*)(rxbuf + cnts)));
						cnts++;
					}
					printf("\n");
				#endif
				break;
		}
		return txsz;
}
#endif

/*
*********************************
Функции клиента
*********************************
*/
#if(_mode_server == 0)
//формирование запроса видео камеры клиента
void	ClietVCamPktCreate(u_int8_t * tbuf)
{
	(*(u_int8_t*)(tbuf + _idtype))		= _idtype_cam_video;	//тип обращения - данные с камеры
	(*(u_int8_t*)(tbuf + _cop))		= _cop_rd;		//код операции - чтение
	(*(u_int8_t*)(tbuf + _vtype))		= _vtype_scr8;		//тип видеоданных - 8 бит
	(*(u_int32_t*)(tbuf + _tcp_sz0))	= _vdaddr + 1;		//размер
}
#endif

#if(_mode_server == 0)
//приём ответа на запрос видео камеры от сервера
void    ClientVCamPktAnswer(u_int8_t * rbuf)
{
	u_int8_t layer;
	u_int16_t	x, y;
	u_int32_t	cnt;
	//
	layer	= (*(u_int8_t*)(rbuf + _vlayer));
	width	= (*(u_int16_t*)(rbuf + _vwidht));    //ширина
	height	= (*(u_int16_t*)(rbuf + _vheight));   //высота
	//
	y 	= 0;
	cnt	= 0;
	while(y < height)
	{
		x = 0;
		while(x < width)
		{
			switch(layer)
			{
				case 0:
					vbuf[x][y] = (*(u_int8_t*)(rbuf + _vdaddr + cnt));
					break;
				case 1:
					vbuf1[x][y] = (*(u_int8_t*)(rbuf + _vdaddr + cnt));
					break;
				case 2:
					vbuf2[x][y] = (*(u_int8_t*)(rbuf + _vdaddr + cnt));
					break;
				case 3:
					vbuf3[x][y] = (*(u_int8_t*)(rbuf + _vdaddr + cnt));
					break;
				default:
					#if(_mode_dbg)
						printf("RD CAM ANSWER not layer\n");
					#endif
					break;
			}
			cnt++;
			x++;
		}
		y++;
	}
}
#endif

/*
**********************************
внешие вызовы
**********************************
*/
#if(_mode_server == 0)
int ReadVideo(u_int8_t * rv, u_int8_t lay)
{
	int res = 0xFF;
	//
	pthread_mutex_lock(&ClientMutex);
	switch(lay)
	{
		case 0:
			memcpy(rv, &vbuf[0][0], (width * height));
			res = 0;
			break;
		case 1:
			memcpy(rv, &vbuf1[0][0], (width * height));
			res = 0;
			break;
		case 2:
			memcpy(rv, &vbuf2[0][0], (width * height));
			res = 0;
			break;
		case 3:
			memcpy(rv, &vbuf3[0][0], (width * height));
			res = 0;
			break;
		default:
			#if(_mode_dbg)
				printf("Read Video not layer\n");
			#endif
			break;
	}
	pthread_mutex_unlock(&ClientMutex);
	return res;
}
#endif

