//wcam.h

#ifndef _wcam_h_
#define _vcam_h_
#include <sys/types.h>
#include "config.h"

#define _szvbuf		(640 * 480)	//размер массива данных
#define _wait_cam	30000		//ожидание цикла камеры

/*
************************
прямая передача картинки
8 бит
************************
*/

extern u_int16_t 	width;			//ширина
extern u_int16_t 	height;			//высота
extern u_int8_t		ocvbuf[_szvbuf];
extern u_int8_t		vtype;

//параметры для процедур
extern u_int8_t		ap1;
extern u_int8_t		ap2;

#if(_main_id_type & _cfg_OpenCV)
//тестовый интерактивеый модуль 1
extern int vtest1(void);
#endif

#if(_main_id_type & _cfg_OpenCV)
//тестовый интерактивеый модуль 2
extern int vtest2(void);
#endif

#if(_main_id_type & _cfg_OpenCV)
//информация о параметрах камеры
extern int vinfo(void);
#endif

#if(_main_id_type & _cfg_OpenCV)
//запуск процесса камеры
extern int CamStart(void);
#endif

#if(_main_id_type & _cfg_OpenCV)
//рабочий процесс камеры
void* CamLoop(void * pr);
#endif

#if(_main_id_type & _cfg_OpenCV)
//чтение данных на передачу клиенту
extern void vdataRead(u_int8_t vtype, u_int8_t * ob);
#endif

#if(_main_id_type & _cfg_OpenCV)
//работа с данными камеры
extern u_int32_t ServerCam(u_int8_t * rxbuf, u_int8_t * txbuf);
#endif

#if(_mode_server == 0)
//работа с камерой для клиета
extern void ClietVCamPktCreate(u_int8_t * tbuf);  //формирование запроса видео камеры клиента
extern void ClientVCamPktAnswer(u_int8_t * rbuf); //приём ответа на запрос видео камеры от сервера
extern int ReadVideo(u_int8_t * rv, u_int8_t lay);
#endif

#endif

