//tdef.h

#ifndef _tdef_h_
#define _tdef_h_
//#include "types.h"
/*
********************
* для всех пакетов *
********************
*/
//заголовок пакета - распределение адресов
//размер данных - описание из 4-х байт
#define _tcp_sz0		0x0000      	//младший байт размера
#define _tcp_sz1		0x0001      	//
#define _tcp_sz2		0x0002      	//
#define _tcp_sz3		0x0003      	//
//идентификатор типа входящего 2 байта
#define _id_tin0		0x0004		//идентификатор типа
#define _id_tin1		0x0005
//идентификатор номера входящего 2 байта
#define _id_nin0		0x0006
#define _id_nin1		0x0007				
//идентификатор типа исходящего 2 байта
#define _id_tout0		0x0008		//идентификатор типа
#define _id_tout1		0x0009
//идентификатор номера исходящего 2 байта
#define _id_nout0		0x000A
#define _id_nout1		0x000B
//общие определения для идентификаторов	
#define _idtype			0x000C      	//тип обращения - выбор режима для выбранного идентификатора 
#define _vcop                   0x000D      	//код операции для идентификатора
//идентификатор времени
#define _mtime0			0x000E
#define _mtime1			0x000F
//начало данных - формат для идентификаторов свой
#define _daddr			0x0010      	//начало данных

/*
************************
* дополнение шапки     *
* для камеры           *
************************
*/
//распределение адресов
#define _vtype			_daddr				//тип видеоданных
#define _vlay			(_daddr + 0x0001)		//номер слоя отображения
#define _vwidht                 (_daddr + 0x0002)		//ширина в случае работы с картинкой
#define _vheight                (_daddr + 0x0004)		//высота в случае работы с картинкой
#define	_ap1			(_daddr + 0x0006)		//параметр 1 для адаптивной бинаризации
#define	_ap2			(_daddr + 0x0007)		//параметр 2 для адаптивной баниризации
#define _vdaddr                 (_daddr + 0x0010)      		//начало данных картинки
//
//#define _size_buf		(16 + (640 * 480))		//размер буфера для приёма и передачи по TCP картинки

/*
***********************
* ТИПОВЫЕ ОПРЕДЕЛЕНИЯ *
***********************
*/
#define _cfg_sens		0x0001		//датчики
#define _cfg_mcntrl		0x0002		//управление устройствами
#define _cfg_video		0x0004		//видеоданные
#define _cfg_space		0x0008		//пространство, положение
#define _cfg_neuro		0x0010		//нейроматрица
#define _cfg_move_cam		0x0020		//поворот камеры
#define _cfg_OpenCV		0x0040		//применение OpenCV
#define _cfg_motors		0x0080		//управление моторами



/*
************************
* определения для      *
* моторов и сервомашин *
************************
*/
//условный маркер веремни
#define _time_mark	0x10
//режим управления
//#define _mode_contrl	0x20	//режим управления
//#define _mode_ctrl0     0       //управление прямое
//#define _mode_ctrl1     1       //управление приближением
//рабочие определения
#define _num_vol_m1	0x30	//номер регистра привода 1
#define _num_vol_m2	0x31	//номер регистра привода 2
#define _num_vol_m3	0x32	//номер регистра привода 3
#define _num_vol_m4	0x33	//номер регистра привода 4
#define _num_pos_s1	0x40	//номер регистра позиции севомашины 1
#define _num_pos_s2	0x41	//номер регистра позиции севомашины 2
#define _num_pos_s3	0x42	//номер регистра позиции севомашины 3
#define _num_pos_s4	0x43	//номер регистра позиции севомашины 4
#define _num_pos_s5	0x44	//номер регистра позиции севомашины 5
#define _num_pos_s6	0x45	//номер регистра позиции севомашины 6
#define _num_pos_s7	0x46	//номер регистра позиции севомашины 7
#define _num_pos_s8	0x47	//номер регистра позиции севомашины 8
#define _num_pos_s9	0x48	//номер регистра позиции севомашины 9
#define _num_pos_s10	0x49	//номер регистра позиции севомашины 10
#define _num_pos_s11	0x4A	//номер регистра позиции севомашины 11
#define _num_pos_s12	0x4B	//номер регистра позиции севомашины 12
#define _num_pos_s13	0x4C	//номер регистра позиции севомашины 13
#define _num_pos_s14	0x4D	//номер регистра позиции севомашины 14
#define _num_pos_s15	0x4E	//номер регистра позиции севомашины 15
#define _num_pos_s16	0x4F	//номер регистра позиции севомашины 16
#define _num_pos_s17	0x50	//номер регистра позиции севомашины 17
#define _num_pos_s18	0x51	//номер регистра позиции севомашины 18
//прочитанные определения
#define _rnum_vol_m1    0x60	//номер регистра привода 1
#define _rnum_vol_m2    0x61	//номер регистра привода 2
#define _rnum_vol_m3    0x62	//номер регистра привода 3
#define _rnum_vol_m4    0x63	//номер регистра привода 4
#define _rnum_pos_s1    0x70	//номер регистра позиции севомашины 1
#define _rnum_pos_s2    0x71	//номер регистра позиции севомашины 2
#define _rnum_pos_s3    0x72	//номер регистра позиции севомашины 3
#define _rnum_pos_s4    0x73	//номер регистра позиции севомашины 4
#define _rnum_pos_s5    0x74	//номер регистра позиции севомашины 5
#define _rnum_pos_s6    0x75	//номер регистра позиции севомашины 6
#define _rnum_pos_s7    0x76	//номер регистра позиции севомашины 7
#define _rnum_pos_s8    0x77	//номер регистра позиции севомашины 8
#define _rnum_pos_s9    0x78	//номер регистра позиции севомашины 9
#define _rnum_pos_s10	0x79	//номер регистра позиции севомашины 10
#define _rnum_pos_s11	0x7A	//номер регистра позиции севомашины 11
#define _rnum_pos_s12	0x7B	//номер регистра позиции севомашины 12
#define _rnum_pos_s13	0x7C	//номер регистра позиции севомашины 13
#define _rnum_pos_s14	0x7D	//номер регистра позиции севомашины 14
#define _rnum_pos_s15	0x7E	//номер регистра позиции севомашины 15
#define _rnum_pos_s16	0x7F	//номер регистра позиции севомашины 16
#define _rnum_pos_s17	0x80	//номер регистра позиции севомашины 17
#define _rnum_pos_s18	0x81	//номер регистра позиции севомашины 18
//
#define _res_modbus	0xF0	//результат обращения по Modbus - последний код ошибки


#endif

