//tema_socket.h


#ifndef _vsocket_h_
#define _vsocket_h_
#include "tdef.h"
#include "config.h"
#include "types.h"

#define _max_sock		10		//максимальное количество входящих соединений
#define _pr_ssleep              300000		//время сна "процесса" прослушивания
#define _cl_pr_ssleep		30000		//время сна "процесса" работы с соединением
#define _SSLEEP			100000		//время ожидания после "ошибки" по select и accept
#define _LSOCKET_TIMEOUT        10000000
#define _time_life		50		//время жизни сокета при отсутствии запросов (удалять процесс если нет обращения)
#define _rSOCKET_TIMEOUT_       7000000 
#define _wSOCKET_TIMEOUT_	7000000
#define _tcp_size		0x200000


//#define _mtime                  0x000A      	//маркер времени для синхронизации (2 байта)
//байты с одресами 0x000С...0x000F резервируем для возможного дальнейшего расширения

//команда для _vcop - собственно код операции
#define	_vcop_rd                0x01        //чтение (от сервера клиенту) - в случае с картинкой байтовый массив картинки
#define _vcop_wr                0x02        //запись (от клиента серверу) - в случае с картинкой параметры
#define _vcop_rdwr              0x03        //чтение-запись


//структура TCP - данные для кервера и клиента
typedef struct _WTCP
{
	U8			work;			//работа - структура
	U16			in_idnum;		//идентификатор номера входящего			
	U16			in_idtype;		//идентификатор типа входящего
	U16			out_idnum;		//идентификатор номера исходящего			
	U16			out_idtype;		//идентификатор типа исходящего
	U32			setcntlive;		//установка счётчика жизни сокета без связи (обрыв соединения)
	U32			cntlive;		//счётчик времени жизни сокета
	U32			set_pr_ssleep;		//время бездействия (сна)
	int			csock;			//сокет клиента
	pthread_t       	pth			//поток точки
} WTCP;

//структура для данных сервера
typedef struct _WSERV
{
	U8			work;			//флаг работы по сокетам
	int			cntclient;		//счётчик клиентов для
	int			idclient;		//номер-идентификатор клиента в массиве
	U8			midcl[_max_sock];	//массив флагов активности клиентов
	pthread_t       	pth[_max_sock];		//массив потоков
	//int			csock;			//сокет клиента
	//U32			setcntlive;		//установка счётчика жизни сокета без связи (обрыв соединения)
	//U32			cntlive;		//счётчик времени жизни сокета
	//U32			set_pr_ssleep;		//время бездействия (сна)
	WTCP			dtcp[_max_sock];	//данные для точки
}WSERV;

extern WSERV			WServer;
extern pthread_mutex_t      	ServerMutex;	

void *   	ListenProcess(void * );			//объявляем процесс прослушивания
void *		ServerProcess(void * mrtucl);		//объявление процесса связи с клиентом
extern int	ServerStart(int port);			//объявляем для всех - в частности для MAIN

#endif

