//wcam.h

#ifndef _wcam_h_
#define _vcam_h_
#include "types.h"
#include "config.h"

#define _szvbuf		(640 * 480)	//размер массива данных
#define _wait_cam	30000		//ожидание цикла камеры

/*
************************
прямая передача картинки
8 бит
************************
*/
#define _vtype_scr8             0x01        	//тип обращения - указывает, что от OpenCV картинка чёрно-белая 8 бит
#define _vtype_scr_at		0x02		//adaptive
#define _vtype_scr_ap		0x03		//gray & adapt


extern U16 	width;
extern U16 	height;
extern U16 	tmark;
extern U8	ocvbuf[_szvbuf];
extern U8	vtype;

//параметры для процедур
extern U8	ap1;
extern U8	ap2;

#if(_main_id_type & _cfg_OpenCV)
//тестовый интерактивеый модуль 1
extern int vtest1(void);
#endif

#if(_main_id_type & _cfg_OpenCV)
//тестовый интерактивеый модуль 2
extern int vtest2(void);
#endif

#if(_main_id_type & _cfg_OpenCV)
//информация о параметрах камеры
extern int vinfo(void);
#endif

#if(_main_id_type & _cfg_OpenCV)
//запуск процесса камеры
extern int CamStart(void);
#endif

#if(_main_id_type & _cfg_OpenCV)
//рабочий процесс камеры
void* CamLoop(void * pr);
#endif

#if(_main_id_type & _cfg_OpenCV)
//чтение данных на передачу клиенту
extern void vdataRead(U8 vtype, U8 * ob);
#endif


#endif

