//id.cpp
#include <string.h>
#include <stdio.h>
#include "id.h"
#include "config.h"
#include "tdef.h"
#include "types.h"
#include "vcsocket.h"

DID	mainID;		//мой идентификатор
DID	serverID;	//идентификатор сервера

//инициализация моей идентификации
void	IDinit(void)
{
	mainID.id_nout	= _main_id_num;
	mainID.id_tout	= _main_id_type;
	mainID.id_nin	= _main_id_num;
	mainID.id_tin	= _main_id_type;
}

//установка (изменение) номера идентификации
void	IDsetNum(U16 num)
{
	mainID.id_nout	= num;
	mainID.id_nin	= num;
}

//проверка и новый номер идентификации клиенту
U32	IDNumForClient(U8 * indat, U8 * outdat)
{
	U8	cmd;
	U16	tin,nin,num;
	//
	num	= 2;
	if((*(U16*)(indat + _id_nout0)) == num)
		return 0;
	//
	printf("--set client num --/n");
	//
	tin	= (*(U16*)(indat + _id_tout0));
	nin	= (*(U16*)(indat + _id_nout0));
	//
	(*(U8*)(outdat + _idtypecmd))	= _idtypecmd_wrnumc;	//меняем номер клиента
	(*(U16*)(outdat + _id_tin0))	= tin;
	(*(U16*)(outdat + _id_nin0))	= nin;
	(*(U8*)(outdat + _idtype))	= _idtype_ID;	//тип обращения
	(*(U16*)(outdat + _idnum_wc))	= num;		//передаём новый номер идентификации
	(*(U8*)(outdat + _cop))		= _cop_wr;	//это ответ
	(*(U16*)(outdat + _mtime0))	= tmark;
	(*(U32*)(outdat + _tcp_sz0))	= _idnum_wc + 2;
	//
	return _idnum_wc + 2;
}

//обработка идентификации
U32	IDworkIDmain(U8 * indat, U8 * outdat)
{
	U8	cmd;
	U16	tin,nin;
	U16	txsz	= 0;
	//
	cmd	= (*(U8*)(indat + _idtypecmd));
	tin	= (*(U16*)(indat + _id_tout0));
	nin	= (*(U16*)(indat + _id_nout0));
	switch(cmd)
	{
		case _idtypecmd_reads:	//чтение идентификатора сервера
		case _idtypecmd_readc:	//чтение идентификатора клиента
			(*(U8*)(outdat + _idtypecmd))	= cmd;		//ответ команды
			(*(U16*)(outdat + _id_tin0))	= tin;
			(*(U16*)(outdat + _id_nin0))	= nin;
			(*(U8*)(outdat + _idtype))	= _idtype_ID;	//тип обращения
			(*(U8*)(outdat + _idcnt))	= 1;		//один идентификатор
			memcpy(outdat + _iddat, &mainID, sizeof(DID));
			(*(U8*)(outdat + _cop))		= _cop_answer;	//это ответ
			(*(U16*)(outdat + _mtime0))	= tmark;
			(*(U32*)(outdat + _tcp_sz0))	= _idcnt + sizeof(DID) + 1;
			txsz	= _idcnt + sizeof(DID) + 1;
			break;
		#if(_mode_server == 0)
		case _idtypecmd_wrnumc:	//запись номера идентификации в клиент
			(*(U8*)(outdat + _idtypecmd))	= cmd;
			(*(U16*)(outdat + _id_tin0))	= tin;
			(*(U16*)(outdat + _id_nin0))	= nin;
			(*(U8*)(outdat + _idtype))	= _idtype_ID;	//тип обращения
			IDsetNum((*(U16*)(indat + _idnum_wc)));		//наш новый номер идентификации
			(*(U8*)(outdat + _cop))		= _cop_answer;	//это ответ
			(*(U16*)(outdat + _mtime0))	= tmark;
			(*(U32*)(outdat + _tcp_sz0))	= _idnum_wc + 2;
			txsz	= _idnum_wc + 2;
			break;
		#endif
		default:
			#if(_mode_dbg)
				printf("IDworkIDmain not work cmd=%i\n", cmd);
				printf("resv bytes: ");
				U32 sz		= (*(U32*)(indat + _tcp_sz0));
				U32 cnts	= 0;
				while(cnts < sz)
				{
					printf("%02X ", (*(U8*)(indat + cnts)));
					cnts++;
				}
				printf("\n");
			#endif
			break;
	}
	return txsz;
}

//формирование запроса идентификации
void	IDworkIDrequest(U8 * outdat)
{
	(*(U32*)(outdat + _tcp_sz0)) 	= (U32)(_idtypecmd + 1);	//размер пакета
	(*(U8*)(outdat + _idtypecmd))	= _idtypecmd_reads;
	(*(U8*)(outdat + _idtype))	= _idtype_ID;
}

//обработка ответа на запрос
void	IDworkIDanswer(U8 * indat)
{
	switch((*(U8*)(indat + _idtypecmd)))
	{
		case _idtypecmd_reads:	//идентификатор сервера
			memcpy(&serverID, indat + _iddat, sizeof(DID));
			break;
		default:
			#if(_mode_dbg)
				printf("IDworkIDanswer not work\n");
				printf("resv bytes: ");
				U32 sz		= (*(U32*)(indat + _tcp_sz0));
				U32 cnts	= 0;
				while(cnts < sz)
				{
					printf("%02X ", (*(U8*)(indat + cnts)));
					cnts++;
				}
				printf("\n");
			#endif
			break;
	}
}

/*
*************************************
внешние запросы
*************************************
*/
#if(_mode_server == 0)
U16 ReadIDTserver(void)
{
	U16 res;
	pthread_mutex_lock(&ClientMutex);
	res	= serverID.id_tout;
	pthread_mutex_unlock(&ClientMutex);
	return res;
}
#endif

#if(_mode_server == 0)
U16 ReadIDNserver(void)
{
	U16 res;
	pthread_mutex_lock(&ClientMutex);
	res	= serverID.id_nout;
	pthread_mutex_unlock(&ClientMutex);
	return res;
}
#endif

