//motors.cpp
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include "motors.h"
#include "tdef.h"
#include "config.h"
//#if((_main_id_type & _cfg_mcntrl) || (_main_id_type & _cfg_move_cam))
	#include "mrtu.h"
//#endif

#if((_main_id_type & _cfg_mcntrl) || (_main_id_type & _cfg_move_cam))
	int 	wait_dev;
	MOTORS	motors;
#endif


#if((_main_id_type & _cfg_mcntrl) || (_main_id_type & _cfg_move_cam))
//тест приводов
int	ctest(char * serial, int baudrate, int symwait)
{
	int	res;
	int	num_work = 0;
	//инициализация
	memset(&motors.motors[0], 0, sizeof(MOTORS::motors[_motors_cnt]));
	memset(&motors.servos[0], 0, sizeof(MOTORS::servos[_servos_cnt]));
	//соединяемся с Arduino
	res = MRTU_Connect(serial, baudrate, symwait);
	if(res != 0)
	{
		#if(define_mode_dbg)
			printf("ERROR connecting to Arduino\n");
		#endif
		return 5;
	}
	//
	while(1)
	{
		num_work = mcontrol(num_work);
		if(num_work == 0)
		{
			printf("M1:%i M2:%i M3:%i M4:%i S1:%i S2:%i T:%i\n",
				motors.rmotors[0], motors.rmotors[1], motors.rmotors[2], motors.rmotors[3],
				motors.rservos[0], motors.rservos[1],
				motors.tloop);
			printf("CMD: ");
			//char c = cvWaitKey(33);
			char c = getchar();
    			if (c == 27)	// нажата ESC
        			break;
			else if(c == 0x31)
			{
				motors.motors[0] += 10;
				motors.motors[1] += 10;
				motors.motors[2] += 10;
				motors.motors[3] += 10;
			}
			else if(c == 0x32)
			{
				motors.motors[0] -= 10;
				motors.motors[1] -= 10;
				motors.motors[2] -= 10;
				motors.motors[3] -= 10;
			}
			else if(c == 0x33)
				motors.servos[0] += 10;
			else if(c == 0x34)
				motors.servos[0] -= 10;
			else if(c == 0x35)
				motors.servos[1] += 10;
			else if(c == 0x36)
				motors.servos[1] -= 10;
			else if(c == 0x30)
			{
				motors.motors[0] = 0;
				motors.motors[1] = 0;
				motors.motors[2] = 0;
				motors.motors[3] = 0;
				motors.servos[0] = 0;
				motors.servos[1] = 0;
			}
			printf("\n");
		}
		usleep(wait_dev);
	}
	//
	MRTU_Disconnect();
	return 0;
}
#endif

#if((_main_id_type & _cfg_mcntrl) || (_main_id_type & _cfg_move_cam))
//управление приводами
int	mcontrol(int num_work)
{
	int	res;
	switch(num_work)
	{
		case 0:	//задание для 4-х моторов
			res = MRTU_CMD_16(1, _num_vol_m1, (U16*)(&motors.motors[0]), 4);
			num_work++;
			break;
		case 1:	//чтение значения 4-х моторов
			res = MRTU_CMD_3(1, _num_vol_m1, (U16*)(&motors.rmotors[0]), 4);
			num_work++;
			break;
		case 2:	//управление положением камеры - два сервопривода
			res = MRTU_CMD_16(1, _num_pos_s1, (U16*)(&motors.servos[0]), 2);
			num_work++;
			break;
		case 3:	//чтение положения камеры - два сервопривода
			res = MRTU_CMD_3(1, _num_pos_s1, (U16*)(&motors.rservos[0]), 2);
			num_work++;
			break;
		case 4: //время цикла
			res = MRTU_CMD_3(1, 2, (U16*)(&motors.tloop), 1);
			num_work = 0;
			break;
		default:
			num_work = 0;
			break;
	}
	return num_work;
}
#endif	


