//tema_socket.h


#ifndef _vsocket_h_
#define _vsocket_h_
#include <pthread.h>
#include "tdef.h"
#include "config.h"
#include "types.h"

#define _max_sock		10		//максимальное количество входящих соединений
#define _pr_ssleep              300000		//время сна "процесса" прослушивания
#define _cl_pr_ssleep		30000		//время сна "процесса" работы с соединением
#define _SSLEEP			100000		//время ожидания после "ошибки" по select и accept
#define _LSOCKET_TIMEOUT        10000000
#define _time_life		10//50		//время жизни сокета при отсутствии запросов (удалять процесс если нет обращения)
#define _rSOCKET_TIMEOUT_       7000000 
#define _wSOCKET_TIMEOUT_	7000000
#define _tcp_size		0x200000	//размер пакета TCP


//#define _mtime                  0x000A      	//маркер времени для синхронизации (2 байта)
//байты с одресами 0x000С...0x000F резервируем для возможного дальнейшего расширения


//структура TCP - данные для сервера и клиента
typedef struct _WTCP
{
	U8			work;			//работа - структура
	DID			id;			//данные идентификатора
	U32			setcntlive;		//установка счётчика жизни сокета без связи (обрыв соединения)
	U32			cntlive;		//счётчик времени жизни сокета
	U32			set_pr_ssleep;		//время бездействия (сна)
	int			csock;			//сокет точки
	pthread_t       	pth;			//поток точки
} WTCP;

//структура для данных сервера
typedef struct _WSERV
{
	U8			work;			//флаг работы по сокетам
	int			cntclient;		//счётчик клиентов для
	int			idclient;		//номер-идентификатор клиента в массиве
	U8			midcl[_max_sock];	//массив флагов активности клиентов
	//pthread_t       	pth[_max_sock];		//массив потоков
	pthread_t		pthlisten;		//поток прослушивания
	//int			csock;			//сокет клиента - передача параметра
	//U32			setcntlive;		//установка счётчика жизни сокета без связи (обрыв соединения)
	//U32			cntlive;		//счётчик времени жизни сокета
	//U32			set_pr_ssleep;		//время бездействия (сна)
	WTCP			dtcp[_max_sock];	//данные для точки
}WSERV;

extern U16 	tmark;
#if(_mode_server == 1)
	extern pthread_mutex_t      	ServerMutex;	
	extern WSERV			WServer;
#else
	extern pthread_mutex_t         	ClientMutex;
	extern WTCP			WClient;
#endif
//
#if(_mode_server == 1)
	extern int	ServerStart(int port);          //объявляем для всех - в частности для MAIN
	void *   	ListenProcess(void * );         //объявляем процесс прослушивания
	void *		ServerProcess(void * cs);       //объявление процесса связи с клиентом
#else
	extern int	ClientStart(char * addr, 
                    		int port);		//объявляем для всех - в частности для MAIN
    	extern int 	ClientStop(void);		//остановить клиента
	void * 		ClientProcess(void * cs);       //поток работы с исходящим соединением
#endif
//статус соединения
extern int StatConnect(void);
//маркер времени
extern int ReadTmark(void);

#endif

